<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCondicaoPagamentoERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCondicaoPagamentoERP
 * @subpackage Arrays
 */
class ArrayOfCondicaoPagamentoERP extends AbstractStructArrayBase
{
    /**
     * The CondicaoPagamentoERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CondicaoPagamentoERP[]
     */
    public $CondicaoPagamentoERP;
    /**
     * Constructor method for ArrayOfCondicaoPagamentoERP
     * @uses ArrayOfCondicaoPagamentoERP::setCondicaoPagamentoERP()
     * @param \StructType\CondicaoPagamentoERP[] $condicaoPagamentoERP
     */
    public function __construct(array $condicaoPagamentoERP = array())
    {
        $this
            ->setCondicaoPagamentoERP($condicaoPagamentoERP);
    }
    /**
     * Get CondicaoPagamentoERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CondicaoPagamentoERP[]|null
     */
    public function getCondicaoPagamentoERP()
    {
        return isset($this->CondicaoPagamentoERP) ? $this->CondicaoPagamentoERP : null;
    }
    /**
     * Set CondicaoPagamentoERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CondicaoPagamentoERP[] $condicaoPagamentoERP
     * @return \ArrayType\ArrayOfCondicaoPagamentoERP
     */
    public function setCondicaoPagamentoERP(array $condicaoPagamentoERP = array())
    {
        foreach ($condicaoPagamentoERP as $arrayOfCondicaoPagamentoERPCondicaoPagamentoERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfCondicaoPagamentoERPCondicaoPagamentoERPItem instanceof \StructType\CondicaoPagamentoERP) {
                throw new \InvalidArgumentException(sprintf('The CondicaoPagamentoERP property can only contain items of \StructType\CondicaoPagamentoERP, "%s" given', is_object($arrayOfCondicaoPagamentoERPCondicaoPagamentoERPItem) ? get_class($arrayOfCondicaoPagamentoERPCondicaoPagamentoERPItem) : gettype($arrayOfCondicaoPagamentoERPCondicaoPagamentoERPItem)), __LINE__);
            }
        }
        if (is_null($condicaoPagamentoERP) || (is_array($condicaoPagamentoERP) && empty($condicaoPagamentoERP))) {
            unset($this->CondicaoPagamentoERP);
        } else {
            $this->CondicaoPagamentoERP = $condicaoPagamentoERP;
        }
        return $this;
    }
    /**
     * Add item to CondicaoPagamentoERP value
     * @throws \InvalidArgumentException
     * @param \StructType\CondicaoPagamentoERP $item
     * @return \ArrayType\ArrayOfCondicaoPagamentoERP
     */
    public function addToCondicaoPagamentoERP(\StructType\CondicaoPagamentoERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CondicaoPagamentoERP) {
            throw new \InvalidArgumentException(sprintf('The CondicaoPagamentoERP property can only contain items of \StructType\CondicaoPagamentoERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CondicaoPagamentoERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CondicaoPagamentoERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CondicaoPagamentoERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CondicaoPagamentoERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CondicaoPagamentoERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CondicaoPagamentoERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CondicaoPagamentoERP
     */
    public function getAttributeName()
    {
        return 'CondicaoPagamentoERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCondicaoPagamentoERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
